package  {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;

	public class Field extends Sprite {
		
		public var blocks:Array = [];
		public var balls:Array = [];
		
		public var platform:Platform;
		
		public function Field(level:Array) {
			buildLevel(level);
			addPlatform();
			startGame();
		}
		
		private function startGame():void {
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		private function onEnterFrame(e:Event):void {
			for (var i:int = 0; i < balls.length; i++) {
				
				var ball:Ball = balls[i];
				
				//Перемещение мяча
				ball.x += ball.dX;
				ball.y += ball.dY;
				
				//Соударение со стенами
				if (ball.x < 0 && ball.dX < 0) ball.invertX();
				if (ball.y < 0 && ball.dY < 0) ball.invertY();
				if (ball.x > 800 && ball.dX > 0) ball.invertX();
				if (ball.y > 600 && ball.dY > 0) ball.invertY();
				
				//Соударение с блоками
				for (var j:int = 0; j < blocks.length; j++) {
					var block:Block = blocks[j];
					
					if (
						ball.x > block.x - 10 && ball.x < block.x + 50 && 
						ball.y > block.y - 10 && ball.y < block.y + 30 
					) {
						
						var dX:Number = Math.abs((block.x + 20) - ball.x)/2;
						var dY:Number = Math.abs((block.y + 10) - ball.y);
						
						if (dX < dY) {
							ball.invertY();
						}else {
							ball.invertX();
						}
						
						blocks.splice(j, 1);
						removeChild(block);
						break;
					}
					
					
				}
				
				//Соударение с платформой
				if (
					ball.x > platform.x - platform.wild / 2 - 10 &&
					ball.x < platform.x + platform.wild / 2 + 10 && 
					ball.y > platform.y - 20 && 
					ball.y < platform.y + 20 &&
					ball.dY > 0
				) {
					
					ball.invertY();
					ball.setSpeed(ball.dX + platform.rotation, ball.dY);
					
				}
				
			}
		}
		
		
		
		private function addPlatform():void {
			platform = new Platform();
			platform.addEventListener(Platform.RELEASE_BALLS, onReleaseBalls);
			addChild(platform);
		}
		
		private function onReleaseBalls(e:Event):void {
			
			var ball:Ball;
			
			while (ball = platform.balls.pop()) {
				
				var point:Point = new Point(ball.x, ball.y);
				
				point = platform.localToGlobal(point);
				
				ball.x = point.x;
				ball.y = point.y;
				
				addChild(ball);
				balls.push(ball);
				
				
				ball.setSpeed(platform.dX, platform.dY - 2);

			}
		}
		
		private function buildLevel(level:Array):void {
			for (var j:int = 0; j < 20; j++) {
				for (var i:int = 0; i < 20; i++) {
					
					var type:int = level[j * 20 + i];
					if (type == 1) generateBlock(i, j);
					
				}
			}
		}
		
		private function generateBlock(i:int, j:int):void {
			var block:Block = new Block(i, j);
			addChild(block);
			blocks.push(block);
		}
		
	}

}